/**
 */
package de.hftstuttgart.buildingphysics;

import de.hftstuttgart.cityunits.model.NullableQuantity;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Life Cycle</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.buildingphysics.LifeCycle#getEmbodiedEnergy <em>Embodied Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.LifeCycle#getEmbodiedCarbon <em>Embodied Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.LifeCycle#getConstructionDescription <em>Construction Description</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.LifeCycle#getDisposalEnergy <em>Disposal Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.LifeCycle#getDisposalCarbon <em>Disposal Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.LifeCycle#getDisposalDescription <em>Disposal Description</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getLifeCycle()
 * @model
 * @generated
 */
public interface LifeCycle extends EObject {
	/**
	 * Returns the value of the '<em><b>Embodied Energy</b></em>' attribute.
	 * The default value is <code>"kWh"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embodied Energy</em>' attribute.
	 * @see #setEmbodiedEnergy(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getLifeCycle_EmbodiedEnergy()
	 * @model default="kWh" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getEmbodiedEnergy();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.LifeCycle#getEmbodiedEnergy <em>Embodied Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Embodied Energy</em>' attribute.
	 * @see #getEmbodiedEnergy()
	 * @generated
	 */
	void setEmbodiedEnergy(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Embodied Carbon</b></em>' attribute.
	 * The default value is <code>"kg"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embodied Carbon</em>' attribute.
	 * @see #setEmbodiedCarbon(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getLifeCycle_EmbodiedCarbon()
	 * @model default="kg" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getEmbodiedCarbon();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.LifeCycle#getEmbodiedCarbon <em>Embodied Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Embodied Carbon</em>' attribute.
	 * @see #getEmbodiedCarbon()
	 * @generated
	 */
	void setEmbodiedCarbon(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Construction Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Construction Description</em>' attribute.
	 * @see #setConstructionDescription(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getLifeCycle_ConstructionDescription()
	 * @model required="true"
	 * @generated
	 */
	String getConstructionDescription();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.LifeCycle#getConstructionDescription <em>Construction Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Construction Description</em>' attribute.
	 * @see #getConstructionDescription()
	 * @generated
	 */
	void setConstructionDescription(String value);

	/**
	 * Returns the value of the '<em><b>Disposal Energy</b></em>' attribute.
	 * The default value is <code>"kWh"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Energy</em>' attribute.
	 * @see #setDisposalEnergy(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getLifeCycle_DisposalEnergy()
	 * @model default="kWh" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getDisposalEnergy();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.LifeCycle#getDisposalEnergy <em>Disposal Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Energy</em>' attribute.
	 * @see #getDisposalEnergy()
	 * @generated
	 */
	void setDisposalEnergy(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Disposal Carbon</b></em>' attribute.
	 * The default value is <code>"kg"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Carbon</em>' attribute.
	 * @see #setDisposalCarbon(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getLifeCycle_DisposalCarbon()
	 * @model default="kg" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getDisposalCarbon();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.LifeCycle#getDisposalCarbon <em>Disposal Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Carbon</em>' attribute.
	 * @see #getDisposalCarbon()
	 * @generated
	 */
	void setDisposalCarbon(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Disposal Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disposal Description</em>' attribute.
	 * @see #setDisposalDescription(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getLifeCycle_DisposalDescription()
	 * @model required="true"
	 * @generated
	 */
	String getDisposalDescription();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.LifeCycle#getDisposalDescription <em>Disposal Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disposal Description</em>' attribute.
	 * @see #getDisposalDescription()
	 * @generated
	 */
	void setDisposalDescription(String value);

} // LifeCycle
