/**
 */
package de.hftstuttgart.buildingphysics;

import de.hftstuttgart.cityunits.model.NullableQuantity;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Window Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getId <em>Id</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getName <em>Name</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getUValue <em>UValue</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getGValue <em>GValue</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getGlazingNumber <em>Glazing Number</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getFrameRatio <em>Frame Ratio</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.WindowType#getLifeCycle <em>Life Cycle</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType()
 * @model
 * @generated
 */
public interface WindowType extends EObject {
	/**
	 * Returns the value of the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Id</em>' attribute.
	 * @see #setId(int)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_Id()
	 * @model id="true" required="true"
	 * @generated
	 */
	int getId();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getId <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Id</em>' attribute.
	 * @see #getId()
	 * @generated
	 */
	void setId(int value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>UValue</b></em>' attribute.
	 * The default value is <code>"W/(m\u00b2\u00b7K)"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>UValue</em>' attribute.
	 * @see #setUValue(NullableQuantity)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_UValue()
	 * @model default="W/(m\u00b2\u00b7K)" dataType="de.hftstuttgart.cityunits.model.quantities.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getUValue();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getUValue <em>UValue</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>UValue</em>' attribute.
	 * @see #getUValue()
	 * @generated
	 */
	void setUValue(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>GValue</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>GValue</em>' attribute.
	 * @see #setGValue(double)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_GValue()
	 * @model required="true"
	 * @generated
	 */
	double getGValue();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getGValue <em>GValue</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GValue</em>' attribute.
	 * @see #getGValue()
	 * @generated
	 */
	void setGValue(double value);

	/**
	 * Returns the value of the '<em><b>Glazing Number</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Glazing Number</em>' attribute.
	 * @see #setGlazingNumber(int)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_GlazingNumber()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getGlazingNumber();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getGlazingNumber <em>Glazing Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Glazing Number</em>' attribute.
	 * @see #getGlazingNumber()
	 * @generated
	 */
	void setGlazingNumber(int value);

	/**
	 * Returns the value of the '<em><b>Frame Ratio</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * In % (between 0 and 100)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Frame Ratio</em>' attribute.
	 * @see #setFrameRatio(int)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_FrameRatio()
	 * @model required="true"
	 * @generated
	 */
	int getFrameRatio();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getFrameRatio <em>Frame Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Frame Ratio</em>' attribute.
	 * @see #getFrameRatio()
	 * @generated
	 */
	void setFrameRatio(int value);

	/**
	 * Returns the value of the '<em><b>Life Cycle</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Life Cycle</em>' containment reference.
	 * @see #setLifeCycle(LifeCycle)
	 * @see de.hftstuttgart.buildingphysics.BuildingPhysicsPackage#getWindowType_LifeCycle()
	 * @model containment="true"
	 * @generated
	 */
	LifeCycle getLifeCycle();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.buildingphysics.WindowType#getLifeCycle <em>Life Cycle</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Life Cycle</em>' containment reference.
	 * @see #getLifeCycle()
	 * @generated
	 */
	void setLifeCycle(LifeCycle value);

} // WindowType
