/**
 */
package de.hftstuttgart.buildingphysics.impl;

import de.hftstuttgart.buildingphysics.BuildingPhysicsPackage;
import de.hftstuttgart.buildingphysics.LifeCycle;

import de.hftstuttgart.cityunits.model.NullableQuantity;

import de.hftstuttgart.cityunits.model.quantities.QuantitiesFactory;
import de.hftstuttgart.cityunits.model.quantities.QuantitiesPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Life Cycle</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.LifeCycleImpl#getEmbodiedEnergy <em>Embodied Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.LifeCycleImpl#getEmbodiedCarbon <em>Embodied Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.LifeCycleImpl#getConstructionDescription <em>Construction Description</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.LifeCycleImpl#getDisposalEnergy <em>Disposal Energy</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.LifeCycleImpl#getDisposalCarbon <em>Disposal Carbon</em>}</li>
 *   <li>{@link de.hftstuttgart.buildingphysics.impl.LifeCycleImpl#getDisposalDescription <em>Disposal Description</em>}</li>
 * </ul>
 *
 * @generated
 */
public class LifeCycleImpl extends MinimalEObjectImpl.Container implements LifeCycle {
	/**
	 * The default value of the '{@link #getEmbodiedEnergy() <em>Embodied Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmbodiedEnergy()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity EMBODIED_ENERGY_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "kWh");

	/**
	 * The cached value of the '{@link #getEmbodiedEnergy() <em>Embodied Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmbodiedEnergy()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity embodiedEnergy = EMBODIED_ENERGY_EDEFAULT;

	/**
	 * The default value of the '{@link #getEmbodiedCarbon() <em>Embodied Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmbodiedCarbon()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity EMBODIED_CARBON_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "kg");

	/**
	 * The cached value of the '{@link #getEmbodiedCarbon() <em>Embodied Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmbodiedCarbon()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity embodiedCarbon = EMBODIED_CARBON_EDEFAULT;

	/**
	 * The default value of the '{@link #getConstructionDescription() <em>Construction Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConstructionDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String CONSTRUCTION_DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getConstructionDescription() <em>Construction Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConstructionDescription()
	 * @generated
	 * @ordered
	 */
	protected String constructionDescription = CONSTRUCTION_DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getDisposalEnergy() <em>Disposal Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalEnergy()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity DISPOSAL_ENERGY_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "kWh");

	/**
	 * The cached value of the '{@link #getDisposalEnergy() <em>Disposal Energy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalEnergy()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity disposalEnergy = DISPOSAL_ENERGY_EDEFAULT;

	/**
	 * The default value of the '{@link #getDisposalCarbon() <em>Disposal Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalCarbon()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity DISPOSAL_CARBON_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "kg");

	/**
	 * The cached value of the '{@link #getDisposalCarbon() <em>Disposal Carbon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalCarbon()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity disposalCarbon = DISPOSAL_CARBON_EDEFAULT;

	/**
	 * The default value of the '{@link #getDisposalDescription() <em>Disposal Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DISPOSAL_DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDisposalDescription() <em>Disposal Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisposalDescription()
	 * @generated
	 * @ordered
	 */
	protected String disposalDescription = DISPOSAL_DESCRIPTION_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LifeCycleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return BuildingPhysicsPackage.Literals.LIFE_CYCLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getEmbodiedEnergy() {
		return embodiedEnergy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEmbodiedEnergy(NullableQuantity newEmbodiedEnergy) {
		NullableQuantity oldEmbodiedEnergy = embodiedEnergy;
		embodiedEnergy = newEmbodiedEnergy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_ENERGY,
					oldEmbodiedEnergy, embodiedEnergy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getEmbodiedCarbon() {
		return embodiedCarbon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEmbodiedCarbon(NullableQuantity newEmbodiedCarbon) {
		NullableQuantity oldEmbodiedCarbon = embodiedCarbon;
		embodiedCarbon = newEmbodiedCarbon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_CARBON,
					oldEmbodiedCarbon, embodiedCarbon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getConstructionDescription() {
		return constructionDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setConstructionDescription(String newConstructionDescription) {
		String oldConstructionDescription = constructionDescription;
		constructionDescription = newConstructionDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					BuildingPhysicsPackage.LIFE_CYCLE__CONSTRUCTION_DESCRIPTION, oldConstructionDescription,
					constructionDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getDisposalEnergy() {
		return disposalEnergy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDisposalEnergy(NullableQuantity newDisposalEnergy) {
		NullableQuantity oldDisposalEnergy = disposalEnergy;
		disposalEnergy = newDisposalEnergy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_ENERGY,
					oldDisposalEnergy, disposalEnergy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getDisposalCarbon() {
		return disposalCarbon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDisposalCarbon(NullableQuantity newDisposalCarbon) {
		NullableQuantity oldDisposalCarbon = disposalCarbon;
		disposalCarbon = newDisposalCarbon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_CARBON,
					oldDisposalCarbon, disposalCarbon));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getDisposalDescription() {
		return disposalDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDisposalDescription(String newDisposalDescription) {
		String oldDisposalDescription = disposalDescription;
		disposalDescription = newDisposalDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_DESCRIPTION, oldDisposalDescription,
					disposalDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_ENERGY:
			return getEmbodiedEnergy();
		case BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_CARBON:
			return getEmbodiedCarbon();
		case BuildingPhysicsPackage.LIFE_CYCLE__CONSTRUCTION_DESCRIPTION:
			return getConstructionDescription();
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_ENERGY:
			return getDisposalEnergy();
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_CARBON:
			return getDisposalCarbon();
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_DESCRIPTION:
			return getDisposalDescription();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_ENERGY:
			setEmbodiedEnergy((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_CARBON:
			setEmbodiedCarbon((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__CONSTRUCTION_DESCRIPTION:
			setConstructionDescription((String) newValue);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_ENERGY:
			setDisposalEnergy((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_CARBON:
			setDisposalCarbon((NullableQuantity) newValue);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_DESCRIPTION:
			setDisposalDescription((String) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_ENERGY:
			setEmbodiedEnergy(EMBODIED_ENERGY_EDEFAULT);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_CARBON:
			setEmbodiedCarbon(EMBODIED_CARBON_EDEFAULT);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__CONSTRUCTION_DESCRIPTION:
			setConstructionDescription(CONSTRUCTION_DESCRIPTION_EDEFAULT);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_ENERGY:
			setDisposalEnergy(DISPOSAL_ENERGY_EDEFAULT);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_CARBON:
			setDisposalCarbon(DISPOSAL_CARBON_EDEFAULT);
			return;
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_DESCRIPTION:
			setDisposalDescription(DISPOSAL_DESCRIPTION_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_ENERGY:
			return EMBODIED_ENERGY_EDEFAULT == null ? embodiedEnergy != null
					: !EMBODIED_ENERGY_EDEFAULT.equals(embodiedEnergy);
		case BuildingPhysicsPackage.LIFE_CYCLE__EMBODIED_CARBON:
			return EMBODIED_CARBON_EDEFAULT == null ? embodiedCarbon != null
					: !EMBODIED_CARBON_EDEFAULT.equals(embodiedCarbon);
		case BuildingPhysicsPackage.LIFE_CYCLE__CONSTRUCTION_DESCRIPTION:
			return CONSTRUCTION_DESCRIPTION_EDEFAULT == null ? constructionDescription != null
					: !CONSTRUCTION_DESCRIPTION_EDEFAULT.equals(constructionDescription);
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_ENERGY:
			return DISPOSAL_ENERGY_EDEFAULT == null ? disposalEnergy != null
					: !DISPOSAL_ENERGY_EDEFAULT.equals(disposalEnergy);
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_CARBON:
			return DISPOSAL_CARBON_EDEFAULT == null ? disposalCarbon != null
					: !DISPOSAL_CARBON_EDEFAULT.equals(disposalCarbon);
		case BuildingPhysicsPackage.LIFE_CYCLE__DISPOSAL_DESCRIPTION:
			return DISPOSAL_DESCRIPTION_EDEFAULT == null ? disposalDescription != null
					: !DISPOSAL_DESCRIPTION_EDEFAULT.equals(disposalDescription);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (embodiedEnergy: ");
		result.append(embodiedEnergy);
		result.append(", embodiedCarbon: ");
		result.append(embodiedCarbon);
		result.append(", constructionDescription: ");
		result.append(constructionDescription);
		result.append(", disposalEnergy: ");
		result.append(disposalEnergy);
		result.append(", disposalCarbon: ");
		result.append(disposalCarbon);
		result.append(", disposalDescription: ");
		result.append(disposalDescription);
		result.append(')');
		return result.toString();
	}

} //LifeCycleImpl
